<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::array&lt; T, mem_manager &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1array.html">array</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1array-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::array&lt; T, mem_manager &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for dlib::array&lt; T, mem_manager &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classdlib_1_1array.png" usemap="#dlib::array_3C_20T_2C_20mem_5Fmanager_20_3E_map" alt=""/>
  <map id="dlib::array_3C_20T_2C_20mem_5Fmanager_20_3E_map" name="dlib::array_3C_20T_2C_20mem_5Fmanager_20_3E_map">
<area href="classdlib_1_1enumerable.html" alt="dlib::enumerable&lt; T &gt;" shape="rect" coords="0,0,190,24"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a25de60d06c64ef42aff68daa00d8d2cb"><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="classdlib_1_1array.html">array</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1array.html#a25de60d06c64ef42aff68daa00d8d2cb">kernel_1a</a></td></tr>
<tr class="separator:a25de60d06c64ef42aff68daa00d8d2cb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad6ab80ce05eca69968a3f32499c51a40"><td class="memItemLeft" align="right" valign="top"><a id="ad6ab80ce05eca69968a3f32499c51a40"></a>
typedef <a class="el" href="classdlib_1_1array.html">array</a>&#160;</td><td class="memItemRight" valign="bottom"><b>kernel_1a_c</b></td></tr>
<tr class="separator:ad6ab80ce05eca69968a3f32499c51a40"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae1844451d6e5b9eda531c32eb53ab490"><td class="memItemLeft" align="right" valign="top"><a id="ae1844451d6e5b9eda531c32eb53ab490"></a>
typedef <a class="el" href="classdlib_1_1array.html">array</a>&#160;</td><td class="memItemRight" valign="bottom"><b>kernel_2a</b></td></tr>
<tr class="separator:ae1844451d6e5b9eda531c32eb53ab490"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0bcffee00b95ed126acd109d0c3c1d92"><td class="memItemLeft" align="right" valign="top"><a id="a0bcffee00b95ed126acd109d0c3c1d92"></a>
typedef <a class="el" href="classdlib_1_1array.html">array</a>&#160;</td><td class="memItemRight" valign="bottom"><b>kernel_2a_c</b></td></tr>
<tr class="separator:a0bcffee00b95ed126acd109d0c3c1d92"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acecdf7086f5ca6c77242d0a96f907c28"><td class="memItemLeft" align="right" valign="top"><a id="acecdf7086f5ca6c77242d0a96f907c28"></a>
typedef <a class="el" href="classdlib_1_1array.html">array</a>&#160;</td><td class="memItemRight" valign="bottom"><b>sort_1a</b></td></tr>
<tr class="separator:acecdf7086f5ca6c77242d0a96f907c28"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a93b398991bdfc8a44b00f5c0d775da3e"><td class="memItemLeft" align="right" valign="top"><a id="a93b398991bdfc8a44b00f5c0d775da3e"></a>
typedef <a class="el" href="classdlib_1_1array.html">array</a>&#160;</td><td class="memItemRight" valign="bottom"><b>sort_1a_c</b></td></tr>
<tr class="separator:a93b398991bdfc8a44b00f5c0d775da3e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aba3dec5e8b52255ff7d6aaa164a45fd8"><td class="memItemLeft" align="right" valign="top"><a id="aba3dec5e8b52255ff7d6aaa164a45fd8"></a>
typedef <a class="el" href="classdlib_1_1array.html">array</a>&#160;</td><td class="memItemRight" valign="bottom"><b>sort_1b</b></td></tr>
<tr class="separator:aba3dec5e8b52255ff7d6aaa164a45fd8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac38ca1c2ab80f865479a19cb3298b9fd"><td class="memItemLeft" align="right" valign="top"><a id="ac38ca1c2ab80f865479a19cb3298b9fd"></a>
typedef <a class="el" href="classdlib_1_1array.html">array</a>&#160;</td><td class="memItemRight" valign="bottom"><b>sort_1b_c</b></td></tr>
<tr class="separator:ac38ca1c2ab80f865479a19cb3298b9fd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad9f4d75bcba97e91a77bc7aeaabdf8f5"><td class="memItemLeft" align="right" valign="top"><a id="ad9f4d75bcba97e91a77bc7aeaabdf8f5"></a>
typedef <a class="el" href="classdlib_1_1array.html">array</a>&#160;</td><td class="memItemRight" valign="bottom"><b>sort_2a</b></td></tr>
<tr class="separator:ad9f4d75bcba97e91a77bc7aeaabdf8f5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a343c975386febd91a32c8a76d36a1a87"><td class="memItemLeft" align="right" valign="top"><a id="a343c975386febd91a32c8a76d36a1a87"></a>
typedef <a class="el" href="classdlib_1_1array.html">array</a>&#160;</td><td class="memItemRight" valign="bottom"><b>sort_2a_c</b></td></tr>
<tr class="separator:a343c975386febd91a32c8a76d36a1a87"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abefed5e03bdd881cc864bb5846f0a36d"><td class="memItemLeft" align="right" valign="top"><a id="abefed5e03bdd881cc864bb5846f0a36d"></a>
typedef <a class="el" href="classdlib_1_1array.html">array</a>&#160;</td><td class="memItemRight" valign="bottom"><b>sort_2b</b></td></tr>
<tr class="separator:abefed5e03bdd881cc864bb5846f0a36d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a209a267c2cbbdbd6d908b7119c69fad3"><td class="memItemLeft" align="right" valign="top"><a id="a209a267c2cbbdbd6d908b7119c69fad3"></a>
typedef <a class="el" href="classdlib_1_1array.html">array</a>&#160;</td><td class="memItemRight" valign="bottom"><b>sort_2b_c</b></td></tr>
<tr class="separator:a209a267c2cbbdbd6d908b7119c69fad3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab5ebb58e8f6e3b6e3031d676fe3aad7f"><td class="memItemLeft" align="right" valign="top"><a id="ab5ebb58e8f6e3b6e3031d676fe3aad7f"></a>
typedef <a class="el" href="classdlib_1_1array.html">array</a>&#160;</td><td class="memItemRight" valign="bottom"><b>expand_1a</b></td></tr>
<tr class="separator:ab5ebb58e8f6e3b6e3031d676fe3aad7f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad34cc21aee1e926af937545722d7edce"><td class="memItemLeft" align="right" valign="top"><a id="ad34cc21aee1e926af937545722d7edce"></a>
typedef <a class="el" href="classdlib_1_1array.html">array</a>&#160;</td><td class="memItemRight" valign="bottom"><b>expand_1a_c</b></td></tr>
<tr class="separator:ad34cc21aee1e926af937545722d7edce"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9041cb1e506a4f92ffacc50952509d47"><td class="memItemLeft" align="right" valign="top"><a id="a9041cb1e506a4f92ffacc50952509d47"></a>
typedef <a class="el" href="classdlib_1_1array.html">array</a>&#160;</td><td class="memItemRight" valign="bottom"><b>expand_1b</b></td></tr>
<tr class="separator:a9041cb1e506a4f92ffacc50952509d47"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa7610c30af48c5a55fe86789667e3abb"><td class="memItemLeft" align="right" valign="top"><a id="aa7610c30af48c5a55fe86789667e3abb"></a>
typedef <a class="el" href="classdlib_1_1array.html">array</a>&#160;</td><td class="memItemRight" valign="bottom"><b>expand_1b_c</b></td></tr>
<tr class="separator:aa7610c30af48c5a55fe86789667e3abb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a265aca438a26bb35c46c519fbbbf575f"><td class="memItemLeft" align="right" valign="top"><a id="a265aca438a26bb35c46c519fbbbf575f"></a>
typedef <a class="el" href="classdlib_1_1array.html">array</a>&#160;</td><td class="memItemRight" valign="bottom"><b>expand_1c</b></td></tr>
<tr class="separator:a265aca438a26bb35c46c519fbbbf575f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a86c6492217f3a4dc32ea35318d0594ed"><td class="memItemLeft" align="right" valign="top"><a id="a86c6492217f3a4dc32ea35318d0594ed"></a>
typedef <a class="el" href="classdlib_1_1array.html">array</a>&#160;</td><td class="memItemRight" valign="bottom"><b>expand_1c_c</b></td></tr>
<tr class="separator:a86c6492217f3a4dc32ea35318d0594ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0b620307a9cb62a875404e1ccadefef9"><td class="memItemLeft" align="right" valign="top"><a id="a0b620307a9cb62a875404e1ccadefef9"></a>
typedef <a class="el" href="classdlib_1_1array.html">array</a>&#160;</td><td class="memItemRight" valign="bottom"><b>expand_1d</b></td></tr>
<tr class="separator:a0b620307a9cb62a875404e1ccadefef9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6e933cf7bb31140a63e2c744d119705b"><td class="memItemLeft" align="right" valign="top"><a id="a6e933cf7bb31140a63e2c744d119705b"></a>
typedef <a class="el" href="classdlib_1_1array.html">array</a>&#160;</td><td class="memItemRight" valign="bottom"><b>expand_1d_c</b></td></tr>
<tr class="separator:a6e933cf7bb31140a63e2c744d119705b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae2e6a211028c8dcd8cc1d2d5dfeb57fb"><td class="memItemLeft" align="right" valign="top"><a id="ae2e6a211028c8dcd8cc1d2d5dfeb57fb"></a>
typedef T&#160;</td><td class="memItemRight" valign="bottom"><b>type</b></td></tr>
<tr class="separator:ae2e6a211028c8dcd8cc1d2d5dfeb57fb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a776aaaf7029c5e8dd46d022ba4a6d3b1"><td class="memItemLeft" align="right" valign="top"><a id="a776aaaf7029c5e8dd46d022ba4a6d3b1"></a>
typedef T&#160;</td><td class="memItemRight" valign="bottom"><b>value_type</b></td></tr>
<tr class="separator:a776aaaf7029c5e8dd46d022ba4a6d3b1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acfd14d6ffad060d280bab75053f7ba8e"><td class="memItemLeft" align="right" valign="top"><a id="acfd14d6ffad060d280bab75053f7ba8e"></a>
typedef mem_manager&#160;</td><td class="memItemRight" valign="bottom"><b>mem_manager_type</b></td></tr>
<tr class="separator:acfd14d6ffad060d280bab75053f7ba8e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6548d2100b2c6a82bdd9bffe00ef7992"><td class="memItemLeft" align="right" valign="top"><a id="a6548d2100b2c6a82bdd9bffe00ef7992"></a>
typedef T *&#160;</td><td class="memItemRight" valign="bottom"><b>iterator</b></td></tr>
<tr class="separator:a6548d2100b2c6a82bdd9bffe00ef7992"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd2b3d91fa9a99e6088fb189c54adbfd"><td class="memItemLeft" align="right" valign="top"><a id="afd2b3d91fa9a99e6088fb189c54adbfd"></a>
typedef const T *&#160;</td><td class="memItemRight" valign="bottom"><b>const_iterator</b></td></tr>
<tr class="separator:afd2b3d91fa9a99e6088fb189c54adbfd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classdlib_1_1enumerable"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classdlib_1_1enumerable')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classdlib_1_1enumerable.html">dlib::enumerable&lt; T &gt;</a></td></tr>
<tr class="memitem:aece453aca3947d8b1f7bf016d5f99cda inherit pub_types_classdlib_1_1enumerable"><td class="memItemLeft" align="right" valign="top">typedef T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1enumerable.html#aece453aca3947d8b1f7bf016d5f99cda">type</a></td></tr>
<tr class="separator:aece453aca3947d8b1f7bf016d5f99cda inherit pub_types_classdlib_1_1enumerable"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ac0c81aae372c6a6c9310cd344baba848"><td class="memItemLeft" align="right" valign="top"><a id="ac0c81aae372c6a6c9310cd344baba848"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>array</b> (unsigned long new_size)</td></tr>
<tr class="separator:ac0c81aae372c6a6c9310cd344baba848"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0d9a03d9219385919072951af4177f67"><td class="memItemLeft" align="right" valign="top"><a id="a0d9a03d9219385919072951af4177f67"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>clear</b> ()</td></tr>
<tr class="separator:a0d9a03d9219385919072951af4177f67"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af0a7296a5cb342d94d7899a37001c425"><td class="memItemLeft" align="right" valign="top"><a id="af0a7296a5cb342d94d7899a37001c425"></a>
const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator[]</b> (unsigned long pos) const</td></tr>
<tr class="separator:af0a7296a5cb342d94d7899a37001c425"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab122de59a116959608bb23092b236ef4"><td class="memItemLeft" align="right" valign="top"><a id="ab122de59a116959608bb23092b236ef4"></a>
T &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator[]</b> (unsigned long pos)</td></tr>
<tr class="separator:ab122de59a116959608bb23092b236ef4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a58c4ca589bd0941a42be4329ff8ed066"><td class="memItemLeft" align="right" valign="top"><a id="a58c4ca589bd0941a42be4329ff8ed066"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>set_size</b> (unsigned long <a class="el" href="classdlib_1_1array.html#a64eac23811ee8278128c020aef2870cb">size</a>)</td></tr>
<tr class="separator:a58c4ca589bd0941a42be4329ff8ed066"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab381905e7684fffcfa704bb0d56651f4"><td class="memItemLeft" align="right" valign="top"><a id="ab381905e7684fffcfa704bb0d56651f4"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>max_size</b> () const</td></tr>
<tr class="separator:ab381905e7684fffcfa704bb0d56651f4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad2628f88054bb6a72bc9eb3db51dc13f"><td class="memItemLeft" align="right" valign="top"><a id="ad2628f88054bb6a72bc9eb3db51dc13f"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>set_max_size</b> (unsigned long max)</td></tr>
<tr class="separator:ad2628f88054bb6a72bc9eb3db51dc13f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2fe01a3fd4a2ef6afdfa63081458c170"><td class="memItemLeft" align="right" valign="top"><a id="a2fe01a3fd4a2ef6afdfa63081458c170"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>swap</b> (<a class="el" href="classdlib_1_1array.html">array</a> &amp;item)</td></tr>
<tr class="separator:a2fe01a3fd4a2ef6afdfa63081458c170"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a64eac23811ee8278128c020aef2870cb"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1array.html#a64eac23811ee8278128c020aef2870cb">size</a> () const</td></tr>
<tr class="separator:a64eac23811ee8278128c020aef2870cb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6e104ee1657ad14c357fef23e04bc4f0"><td class="memItemLeft" align="right" valign="top"><a id="a6e104ee1657ad14c357fef23e04bc4f0"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>at_start</b> () const</td></tr>
<tr class="separator:a6e104ee1657ad14c357fef23e04bc4f0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a59464da585f00d68dd41aee5c83b0a46"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1array.html#a59464da585f00d68dd41aee5c83b0a46">reset</a> () const</td></tr>
<tr class="separator:a59464da585f00d68dd41aee5c83b0a46"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a920e5b64c4e9d28f9ce628b60b89652f"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1array.html#a920e5b64c4e9d28f9ce628b60b89652f">current_element_valid</a> () const</td></tr>
<tr class="separator:a920e5b64c4e9d28f9ce628b60b89652f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af7c13528104debe9ba1d3e4aef9aff7d"><td class="memItemLeft" align="right" valign="top">const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1array.html#af7c13528104debe9ba1d3e4aef9aff7d">element</a> () const</td></tr>
<tr class="separator:af7c13528104debe9ba1d3e4aef9aff7d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a45bbedcc6fa9c8002b7f6fb72940926e"><td class="memItemLeft" align="right" valign="top">T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1array.html#a45bbedcc6fa9c8002b7f6fb72940926e">element</a> ()</td></tr>
<tr class="separator:a45bbedcc6fa9c8002b7f6fb72940926e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3dafa30e65d90b1d54dc68e3e3d632b3"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1array.html#a3dafa30e65d90b1d54dc68e3e3d632b3">move_next</a> () const</td></tr>
<tr class="separator:a3dafa30e65d90b1d54dc68e3e3d632b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abc99d0542f42370afe05b01dab30cdf0"><td class="memItemLeft" align="right" valign="top"><a id="abc99d0542f42370afe05b01dab30cdf0"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>sort</b> ()</td></tr>
<tr class="separator:abc99d0542f42370afe05b01dab30cdf0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abb6b6d38bc32be1aa2ff7c7bd55d3067"><td class="memItemLeft" align="right" valign="top"><a id="abb6b6d38bc32be1aa2ff7c7bd55d3067"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>resize</b> (unsigned long new_size)</td></tr>
<tr class="separator:abb6b6d38bc32be1aa2ff7c7bd55d3067"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af50877e0212d11594df278e18d09359e"><td class="memItemLeft" align="right" valign="top"><a id="af50877e0212d11594df278e18d09359e"></a>
const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>back</b> () const</td></tr>
<tr class="separator:af50877e0212d11594df278e18d09359e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa7c5556c3b688b8a735966bcf56336b7"><td class="memItemLeft" align="right" valign="top"><a id="aa7c5556c3b688b8a735966bcf56336b7"></a>
T &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>back</b> ()</td></tr>
<tr class="separator:aa7c5556c3b688b8a735966bcf56336b7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa56e9caaed431201b9725f3b2c7d3fac"><td class="memItemLeft" align="right" valign="top"><a id="aa56e9caaed431201b9725f3b2c7d3fac"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>pop_back</b> ()</td></tr>
<tr class="separator:aa56e9caaed431201b9725f3b2c7d3fac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab2eabdfece74af359c1fb6abdd9ab251"><td class="memItemLeft" align="right" valign="top"><a id="ab2eabdfece74af359c1fb6abdd9ab251"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>pop_back</b> (T &amp;item)</td></tr>
<tr class="separator:ab2eabdfece74af359c1fb6abdd9ab251"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4cae4c8d32d0e9df68af4224b8ff5889"><td class="memItemLeft" align="right" valign="top"><a id="a4cae4c8d32d0e9df68af4224b8ff5889"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>push_back</b> (T &amp;item)</td></tr>
<tr class="separator:a4cae4c8d32d0e9df68af4224b8ff5889"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1d173f3b0d421a2a14715ebc764e39a5"><td class="memItemLeft" align="right" valign="top"><a id="a1d173f3b0d421a2a14715ebc764e39a5"></a>
iterator&#160;</td><td class="memItemRight" valign="bottom"><b>begin</b> ()</td></tr>
<tr class="separator:a1d173f3b0d421a2a14715ebc764e39a5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9baf5169857d0e5fece4edb1da3b742d"><td class="memItemLeft" align="right" valign="top"><a id="a9baf5169857d0e5fece4edb1da3b742d"></a>
const_iterator&#160;</td><td class="memItemRight" valign="bottom"><b>begin</b> () const</td></tr>
<tr class="separator:a9baf5169857d0e5fece4edb1da3b742d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aff9142716e6b6b4635a768e5148456ff"><td class="memItemLeft" align="right" valign="top"><a id="aff9142716e6b6b4635a768e5148456ff"></a>
iterator&#160;</td><td class="memItemRight" valign="bottom"><b>end</b> ()</td></tr>
<tr class="separator:aff9142716e6b6b4635a768e5148456ff"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8ca5cd74e883182141f39755e06960d5"><td class="memItemLeft" align="right" valign="top"><a id="a8ca5cd74e883182141f39755e06960d5"></a>
const_iterator&#160;</td><td class="memItemRight" valign="bottom"><b>end</b> () const</td></tr>
<tr class="separator:a8ca5cd74e883182141f39755e06960d5"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:a8743beea610b3431f82a9b308ac0853a"><td class="memItemLeft" align="right" valign="top"><a id="a8743beea610b3431f82a9b308ac0853a"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>array</b> (<a class="el" href="classdlib_1_1array.html">array</a>&lt; T &gt; &amp;)</td></tr>
<tr class="separator:a8743beea610b3431f82a9b308ac0853a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af5c5928b3ec1c5488eddead22ddf6058"><td class="memItemLeft" align="right" valign="top"><a id="af5c5928b3ec1c5488eddead22ddf6058"></a>
<a class="el" href="classdlib_1_1array.html">array</a>&lt; T &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (<a class="el" href="classdlib_1_1array.html">array</a>&lt; T &gt; &amp;)</td></tr>
<tr class="separator:af5c5928b3ec1c5488eddead22ddf6058"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a3e0bb127df83c256561fe75b8a0ffeb2"><td class="memItemLeft" align="right" valign="top"><a id="a3e0bb127df83c256561fe75b8a0ffeb2"></a>
mem_manager::template rebind&lt; T &gt;::other&#160;</td><td class="memItemRight" valign="bottom"><b>pool</b></td></tr>
<tr class="separator:a3e0bb127df83c256561fe75b8a0ffeb2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3387401e6d1afd4bc4cbf5c4f2883068"><td class="memItemLeft" align="right" valign="top"><a id="a3387401e6d1afd4bc4cbf5c4f2883068"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>array_size</b></td></tr>
<tr class="separator:a3387401e6d1afd4bc4cbf5c4f2883068"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aab8d4f5ffa0aff3447552d88e44b1b43"><td class="memItemLeft" align="right" valign="top"><a id="aab8d4f5ffa0aff3447552d88e44b1b43"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>max_array_size</b></td></tr>
<tr class="separator:aab8d4f5ffa0aff3447552d88e44b1b43"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7c894a282caf6ee97c41ab7e93407a19"><td class="memItemLeft" align="right" valign="top"><a id="a7c894a282caf6ee97c41ab7e93407a19"></a>
T *&#160;</td><td class="memItemRight" valign="bottom"><b>array_elements</b></td></tr>
<tr class="separator:a7c894a282caf6ee97c41ab7e93407a19"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2cb1040ed563f0c82b18f401f6fc3d11"><td class="memItemLeft" align="right" valign="top"><a id="a2cb1040ed563f0c82b18f401f6fc3d11"></a>
T *&#160;</td><td class="memItemRight" valign="bottom"><b>pos</b></td></tr>
<tr class="separator:a2cb1040ed563f0c82b18f401f6fc3d11"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5c8f74948e6cc3dd05a175ea3ac805d5"><td class="memItemLeft" align="right" valign="top"><a id="a5c8f74948e6cc3dd05a175ea3ac805d5"></a>
T *&#160;</td><td class="memItemRight" valign="bottom"><b>last_pos</b></td></tr>
<tr class="separator:a5c8f74948e6cc3dd05a175ea3ac805d5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1944925461f0accaf316d6c56878c370"><td class="memItemLeft" align="right" valign="top"><a id="a1944925461f0accaf316d6c56878c370"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>_at_start</b></td></tr>
<tr class="separator:a1944925461f0accaf316d6c56878c370"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_methods_classdlib_1_1enumerable"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classdlib_1_1enumerable')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classdlib_1_1enumerable.html">dlib::enumerable&lt; T &gt;</a></td></tr>
<tr class="memitem:a328c55c7c5df14e115cd502e9756e8a3 inherit pro_methods_classdlib_1_1enumerable"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1enumerable.html">enumerable</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1enumerable.html#a328c55c7c5df14e115cd502e9756e8a3">operator=</a> (const <a class="el" href="classdlib_1_1enumerable.html">enumerable</a> &amp;)</td></tr>
<tr class="separator:a328c55c7c5df14e115cd502e9756e8a3 inherit pro_methods_classdlib_1_1enumerable"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Typedef Documentation</h2>
<a id="a25de60d06c64ef42aff68daa00d8d2cb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a25de60d06c64ef42aff68daa00d8d2cb">&#9670;&nbsp;</a></span>kernel_1a</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T, typename mem_manager = default_memory_manager&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="classdlib_1_1array.html">array</a> <a class="el" href="classdlib_1_1array.html">dlib::array</a>&lt; T, mem_manager &gt;::<a class="el" href="classdlib_1_1array.html#a25de60d06c64ef42aff68daa00d8d2cb">kernel_1a</a></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">INITIAL VALUE
    - array_size == 0    
    - max_array_size == 0
    - array_elements == 0
    - pos == 0
    - last_pos == 0
    - _at_start == true

CONVENTION
    - array_size == size() 
    - max_array_size == max_size() 
    - if (max_array_size &gt; 0)
        - array_elements == pointer to max_array_size elements of type T
    - else
        - array_elements == 0

    - if (array_size &gt; 0) 
        - last_pos == array_elements + array_size - 1
    - else
        - last_pos == 0


    - at_start() == _at_start 
    - current_element_valid() == pos != 0
    - if (current_element_valid()) then
        - *pos == element()
</pre><p> ! </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a920e5b64c4e9d28f9ce628b60b89652f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a920e5b64c4e9d28f9ce628b60b89652f">&#9670;&nbsp;</a></span>current_element_valid()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1array.html">dlib::array</a>&lt; T, mem_manager &gt;::current_element_valid </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - #current_element_valid() == false 
    - #at_start() == true
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a1d8826bb2077f454da01103773f892c6">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a45bbedcc6fa9c8002b7f6fb72940926e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a45bbedcc6fa9c8002b7f6fb72940926e">&#9670;&nbsp;</a></span>element() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">T &amp; <a class="el" href="classdlib_1_1array.html">dlib::array</a>&lt; T, mem_manager &gt;::element </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - current_element_valid() == true
ensures
    - returns a const reference to the current element
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a43a289e594edbf10a8300f5b49569524">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<a id="af7c13528104debe9ba1d3e4aef9aff7d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af7c13528104debe9ba1d3e4aef9aff7d">&#9670;&nbsp;</a></span>element() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const T &amp; <a class="el" href="classdlib_1_1array.html">dlib::array</a>&lt; T, mem_manager &gt;::element </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns true if we are currently at a valid element else
      returns false 
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#ac8b8efc630a1ee6abe6ba2a153bf0047">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a3dafa30e65d90b1d54dc68e3e3d632b3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3dafa30e65d90b1d54dc68e3e3d632b3">&#9670;&nbsp;</a></span>move_next()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1array.html">dlib::array</a>&lt; T, mem_manager &gt;::move_next </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - current_element_valid() == true
ensures
    - returns a non-const reference to the current element
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a1b204b94acddc602ed8750731c7550ce">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a59464da585f00d68dd41aee5c83b0a46"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a59464da585f00d68dd41aee5c83b0a46">&#9670;&nbsp;</a></span>reset()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1array.html">dlib::array</a>&lt; T, mem_manager &gt;::reset </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns true if *this represents one position before the first element
      in the container (this would also make the current element invalid) 
      else returns false                
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a2904ebf4bc18e60b5669509416827a3e">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a64eac23811ee8278128c020aef2870cb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a64eac23811ee8278128c020aef2870cb">&#9670;&nbsp;</a></span>size()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename mem_manager &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long <a class="el" href="classdlib_1_1array.html">dlib::array</a>&lt; T, mem_manager &gt;::size </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - moves to the next element.  i.e. #element() will now 
      return the next element in the container 
    - the return value will be equal to #current_element_valid() 
    - #at_start() == false 

    - returns true if there is another element 
    - returns false if there are no more elements in the container
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a3181bdae2392e004881efe86bb2cd412">dlib::enumerable&lt; T &gt;</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="array__kernel_8h_source.html">array_kernel.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
